searchData={"items":[{"type":"module","title":"Kcl","doc":"pure Elixir NaCl crypto suite substitute\n\nThe `box` and `unbox` functions exposed here are the equivalent\nof NaCl's:\n\n- `crypto_box_curve25519xsalsa20poly1305`\n- `crypto_box_curve25519xsalsa20poly1305_open`","ref":"Kcl.html"},{"type":"function","title":"Kcl.auth/2","doc":"`crypto_auth` equivalent","ref":"Kcl.html#auth/2"},{"type":"function","title":"Kcl.box/3","doc":"","ref":"Kcl.html#box/3"},{"type":"function","title":"Kcl.box/4","doc":"box up an authenticated packet","ref":"Kcl.html#box/4"},{"type":"function","title":"Kcl.derive_public_key/2","doc":"derive a public key from a private key","ref":"Kcl.html#derive_public_key/2"},{"type":"function","title":"Kcl.generate_key_pair/1","doc":"generate a `{private, public}` key pair","ref":"Kcl.html#generate_key_pair/1"},{"type":"type","title":"Kcl.key/0","doc":"public or private key","ref":"Kcl.html#t:key/0"},{"type":"type","title":"Kcl.key_variety/0","doc":"key varieties","ref":"Kcl.html#t:key_variety/0"},{"type":"type","title":"Kcl.key_vis/0","doc":"key visibility","ref":"Kcl.html#t:key_vis/0"},{"type":"function","title":"Kcl.new_connection_state/3","doc":"create an inital state for a peer connection\n\nA convenience wrapper around `Kcl.State.init` and `Kcl.State.new_peer`","ref":"Kcl.html#new_connection_state/3"},{"type":"type","title":"Kcl.nonce/0","doc":"shared nonce","ref":"Kcl.html#t:nonce/0"},{"type":"function","title":"Kcl.secretbox/3","doc":"box based on a shared secret","ref":"Kcl.html#secretbox/3"},{"type":"function","title":"Kcl.secretunbox/3","doc":"unbox based on a shared secret","ref":"Kcl.html#secretunbox/3"},{"type":"function","title":"Kcl.shared_secret/2","doc":"pre-compute a shared key\n\nMainly useful in a situation where many messages will be exchanged.","ref":"Kcl.html#shared_secret/2"},{"type":"function","title":"Kcl.sign/3","doc":"sign a message\n\nIf only the secret key is provided, the public key will be derived therefrom.\nThis can add significant overhead to the signing operation.","ref":"Kcl.html#sign/3"},{"type":"function","title":"Kcl.sign_to_encrypt/2","doc":"convert a signing Ed25519 key to a Curve25519 encryption key","ref":"Kcl.html#sign_to_encrypt/2"},{"type":"type","title":"Kcl.signature/0","doc":"computed signature","ref":"Kcl.html#t:signature/0"},{"type":"function","title":"Kcl.unbox/3","doc":"","ref":"Kcl.html#unbox/3"},{"type":"function","title":"Kcl.unbox/4","doc":"unbox an authenticated packet\n\nReturns `:error` when the packet contents cannot be authenticated, otherwise\nthe decrypted payload and updated state.","ref":"Kcl.html#unbox/4"},{"type":"function","title":"Kcl.valid_auth?/3","doc":"Compare `auth` HMAC","ref":"Kcl.html#valid_auth?/3"},{"type":"function","title":"Kcl.valid_signature?/3","doc":"validate a message signature","ref":"Kcl.html#valid_signature?/3"},{"type":"module","title":"Kcl.State","doc":"On-going KCl session state\n\nSome helpers to maintain state between messages","ref":"Kcl.State.html"},{"type":"function","title":"Kcl.State.init/2","doc":"Initialize a new state\n\nThe private key will be used to derive the public one, if such is\nnot supplied. There is, otherwise, no verification that the supplied\nkeys form a valid pair.","ref":"Kcl.State.html#init/2"},{"type":"function","title":"Kcl.State.new_peer/2","doc":"update the state for a new peer\n\nThe shared secret is computed from the state and new peer public key.\nThe previous_nonce value is also reset to `0`.","ref":"Kcl.State.html#new_peer/2"},{"type":"type","title":"Kcl.State.t/0","doc":"","ref":"Kcl.State.html#t:t/0"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.1"}}